;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsm2.asm
;Author: IAO
;URL: 
;
;Description: To send bits for the Parallel Port.   
;
;Created:  20-03-2006 Esp. (Eng. 03-20-2006)
;Finished: 21-03-2006 Esp. (Eng. 03-21-2006)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 
;
;-Programa para escribir en el LPT Port 378h e incremente el valor de los leds. 
;-Funciona Bin. Aqu se saca el valor por OUT.
;-Salir del Programa con: "Esc".

;-Compilar con Masm. Por tener Masm32 y Masm16. Cambi Link.exe por DosLnk.exe
;ML /c LedAsm2.asm
;DosLnk /tiny LedAsm2.obj,LedAsm2.com;

.model tiny
.data
org 100h
Var1 DB ?

.code 
.startup
Start:
MOV AL,1 	;Aqui debe ser AL porque al ser 8 bit queda en blanco
		;en 1 pasada si es AX

next_situation:
MOV DX,378h
OUT DX,AL 

CALL Delay
ROL AL, 1    	; rotate bit.

;Keep original AL
MOV     Var1, AL

;============================
;Check for ESC key to reboot:
; check for keystroke in keyboard buffer:
Key:
MOV     AH, 1
INT     16h
JZ      Sigue

;Get keystroke from keyboard:
; (remove from the buffer)
MOV     AH, 0 
INT     16h

;Press 'ESC' to exit.
CMP     AL, 1Bh
JNZ     Sigue
INT     19h
;============================

Sigue:
;Restore original AL
MOV     AL,Var1

JMP next_situation

;============================
;Rutina Delay
;============================
Delay:   	MOV	BX,10000 	;Con este valor 8000 trabaja bien el retardo
AQUI1:	MOV    	CX,8000	
AQUI2:	DEC	CX		
	OR	CX,0
	JNZ	AQUI2
	DEC	BX
	JNZ	AQUI1
	RET

.exit 	 
END

