;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsmG2.asm
;Author: IAO
;URL: 
;
;Description: To send bits for the Parallel Port.  
;
;Created:  14-09-2005 Esp. (Eng. 09-14-2005)
;Finished: 20-09-2005 Esp. (Eng. 09-20-2005)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

;#########################################################################
.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include LedAsmG.inc

.code
start:
	;call LoadDLL		;Funciona pero quera usar invoke
	invoke LoadDLL,hLib

	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke FreeLibrary,hLib  
	invoke	ExitProcess,0

;########################################################################
DlgProc	proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		;initialization here

		; Tres Lineas del Icono "Carita feliz"		
        invoke LoadIcon,hInstance,200
        mov hIcon, eax
        invoke SendMessage,hWin,WM_SETICON,1,hIcon

    	;Procesa los mensajes de los botones
    	mov	eax,uMsg    
		.elseif	eax==WM_COMMAND
		mov eax,wParam
		shr edx,16
		.if edx==BN_CLICKED
			.if ax==IDOK
					invoke P_out1,DWORD,DWORD   ;OFF al Salir.
					invoke	SendMessage,hWin,WM_CLOSE,0,0	
				.elseif ax==IDCANCEL
					invoke P_out1,DWORD,DWORD   ;OFF al Salir.
					invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL			
				
				.elseif ax==IDC_BTN1	;OFF
					;call  P_out1    	;Funciona pero se tranca el programa
					invoke P_out1,DWORD,DWORD
				.elseif ax==IDC_BTN2	;On
					;call  P_out2    	;Funciona pero se tranca el programa	
					invoke P_out2,DWORD,DWORD				
			.endif
		.endif

	;Puede estar aqu o despus de invocar al Icono.
	mov	eax,uMsg
	.elseif	eax==WM_CLOSE 
	invoke	EndDialog,hWin,0

	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

;########################################################################
LoadDLL PROC hLibrary:DWORD
;Carga de la DLL y Funcion
	  invoke LoadLibrary,addr DLLName
        .if eax==NULL
                invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
        	.else
                mov hLib,eax
                invoke GetProcAddress,hLib,addr FunctionName
                .if eax==NULL
                        invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                
                .else
                mov OutAddr,eax     ;Carga el handle en OutAddr
                ;call P_out1          ; Get the addresses of the procedures
           .endif
	 .endif
;Final Carga DLL y Funcion	
	
	ret
LoadDLL endp

;########################################################################
;Apaga los Led's
P_out1 PROC PortAddress:DWORD , data:DWORD
		mov data,0    ;240 ;128 ;  ;255        
		push data
		mov  PortAddress,378h
		push PortAddress

;Puesto Aqui funciona.
		call [OutAddr]    ;Despliega el Contenido de TestAddr

		pop  PortAddress	
		pop  data
		
		
    ret
P_out1 endp

;########################################################################
;Enciende los Led's
P_out2 PROC PortAddress2:DWORD , data2:DWORD
		mov data2,255    ;240 ;128 ;  ;255        
		push data2
		mov  PortAddress2,378h
		push PortAddress2

;Puesto Aqui funciona.
		call [OutAddr]    ;Despliega el Contenido de TestAddr
		
		pop  PortAddress2	
		pop  data2
		
		
    ret
P_out2 endp

;########################################################################
end start
