comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"

        This example shows how to use the preprocessor code (macros) supplied with the latest service pack for
        MASM32 for file IO code.
        ----------------------------------------------------- *
;
    include \masm32\include\masm32rt.inc
    include winio.inc
    includelib winio.lib

    .data
      hPhysMem  dd 0
      
    .code
start: 
    invoke InitializeWinIo
    invoke MapPhysToLin, 400h, 64, ADDR hPhysMem
    mov   ebx, eax
    movzx eax, WORD PTR[ebx+8] 
;Etiquetado para no ejecucin.
    ;print uhex$(eax),"h",13,10
;

    call main

invoke ShutdownWinIo

;Etiquetado para no ejecucin.
        ;inkey "Press any key to exit..."

    exit
;

main proc
    LOCAL hFile :DWORD                         ; file handle
    LOCAL bwrt  :DWORD                         ; variable for bytes written
    LOCAL txt    :DWORD                         ; text handle

;Con este puntero, cargado en EAX aparece la direccin en el archivo "Addr.ini".
    movzx eax, WORD PTR[ebx+8]            ;Sin esto escribe un valor erroneo en el "Addr.ini"
    mov txt,uhex$(eax)                               ;Luego cargamos el valor hexadecimal en txt.
 
    .if rv(exist,"Addr.ini") != 0                      ;if file already exists
      test fdelete(txt), eax                           ;delete it
    .endif

  ; ----------------------------------
  ; create a file and write data to it
  ; ----------------------------------
   mov hFile, fcreate("Addr.ini")                  ; create the file
   mov bwrt, fwrite(hFile,txt,len(txt))            ; write data to it
   fclose hFile                                          ; close the file

    ret
main endp
; 
end start
