;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsmG5
;Author: IAO
;URL: 
;
;Description:  Program send bits to LPT
;
;Created: 05-08-2005  Esp. (Eng. 08-05-2005)
;Finished: 06-02-2006 Esp. (Eng. 02-06-2005)
;Modified: 18-02-2006 Esp. 
;Email: rdpt465@yahoo.es
;Trabajando bin. (working well)
;With a good help from MichaelW,CrisLesli,Emperor (www.masmforum.com)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include LedAsmG5.inc

.code
start:
	invoke  LoadDLL,hLib			;Load .Dll (Inpout32)
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax 
	
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL

	invoke  FreeLibrary,hLib
	invoke	ExitProcess,0

;########################################################################
DlgProc	proc  hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL pMem  :DWORD
    LOCAL rpos  :DWORD
    LOCAL buffer[128]:BYTE
    
    mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		;initialization here
		invoke GetStartupInfo, ADDR SInfo
		invoke CreateProcess, ADDR PName, NULL, NULL, NULL, FALSE,\
		NORMAL_PRIORITY_CLASS, NULL, NULL, ADDR SInfo, ADDR PInfo
		invoke WaitForSingleObject, PInfo.hProcess, INFINITE
		
		;Esto es para el Edit BOX. "Address LPT1".
		invoke GetDlgItem, hWin, IDC_EDT1

		;-Para que aparezca el VALOR en el "EditText box".
		mov hEdit1, FUNC(GetDlgItem,hWin,1009)
		
        mov pMem, InputFile("Addr.ini")     ; load the INI file into memory
        mov rpos, 0                         ; zero the read position pointer

        mov rpos, linein$(pMem,ADDR buffer,rpos)
        invoke SendMessage,hEdit1,WM_SETTEXT,0,ADDR buffer
        free pMem                           ; free the memory  

		;Esto es para el Edit BOX. "Value Write to Port".
		invoke GetDlgItem, hWin, IDC_EDT2
		mov hEdit2, eax

;======================================

		;Esto es para el BitMap (.BMP) del Led gris.
		invoke BitmapFromResource,hInstance,IDR_JPG
		mov	hBmp,eax
		mov Carry,eax
		invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp


		;->This is to the Icono.	
		invoke LoadIcon,hInstance,200
        mov hIcon, eax
        invoke SendMessage,hWin,WM_SETICON,1,hIcon
		;-<
		
		;Put all Check Box Unchecked		(Parece que no hacen falta)		  
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
		mov bValue1,0
		

		;Para Encender los Led's Rojos de "Salida Puerto".
		invoke BitmapFromResource,hInstance,IDR_JPG1
		mov	hBmp1,eax

		 	
		.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==1 ;"Cero To Port"					
				mov eax,0
				invoke P_out1,1024,ecx
				;Procedimiento para Inicializar Led y CheckBox.
				invoke ClearAll,hWin
			
			.elseif eax==2 ;"EXIT"
			;->Esto es lo que pregunta si sale del programa.
			;Puesto aqu funcion Bin.
			invoke MessageBox,hWin,addr Pregnta,addr Salir,MB_YESNO or MB_ICONQUESTION
       		 .if eax == IDNO
       		  ret
	    	 .else
 			 invoke SendMessage,hWin,WM_CLOSE,0,0
       		 .endif
			;-<

			invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL

;=========================================================================
		;Procedimiento Para los Check. ---- IDC_CHK0 es igual a 1001
		;Sin esto no trabaja el programa.
		.elseif eax == 1001 || 1002 || 1003 || 1004\
					|| 1005 || 1006 || 1007 || 1008
				invoke CheckProc,hWin 
			
			mov Val_Dat,ecx		;Para el Edit BOX "Value Write to Port"			
					
			;Para Sacar el Valor hacia el LPT
			mov eax,ecx 			;Load register ECX in register EAX.
			invoke P_out1,1024,ecx 	;Out to LPT Port.

			;Para que muestre el valor en el EDIT BOX.
			INVOKE SetDlgItemInt,hWin,IDC_EDT2,Val_Dat,FALSE
			;mov hEdit2,eax 

;=========================================================================
			.endif
		.endif
	.elseif	eax==WM_CLOSE  	
				mov eax,0
				invoke P_out1,1024,ecx

		invoke	EndDialog,hWin,0
	
		;Here delete file Addr.ini.
    	.if rv(exist,"Addr.ini") != 0         ; If file already exists
      	test fdelete("Addr.ini"), eax         ; Delete it
    	.endif		
	
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

;========================================================================
LoadDLL PROC hLibrary:DWORD
;Carga de la DLL y Funcion
	  invoke LoadLibrary,addr DLLName
        .if eax==NULL
                invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
        	.else
                mov hLib,eax
                invoke GetProcAddress,hLib,addr FunctionName
                .if eax==NULL
                    invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                .else
                mov OutAddr,eax     ;Carga el handle en OutAddr
                ;call P_out1        ;Get the addresses of the procedures
           .endif
	 .endif
;Final Carga DLL y Funcion Out32	
	
	ret
LoadDLL endp

;========================================================================
P_out1 PROC PortAddress:DWORD, data:DWORD
			
		mov data,eax
		push data
		mov  PortAddress,378h
		push PortAddress

 		;Put here work.
		call [OutAddr]    ;Despliega el Contenido de OutAddr

		pop  PortAddress	
		pop  data
    ret
P_out1 endp

;========================================================================
CheckProc PROC hWin:DWORD 

	;Here it begins to revise the CHECK-BOX
		;-CHECK Cero----------------------
	.if eax == IDC_CHK0	;ID Name == ID 1001 in .DLG
		invoke IsDlgButtonChecked,hWin,IDC_CHK0
		;invoke SendDlgItemMessage,hWin,IDC_CHK0,BM_GETCHECK, 0, 0  ;It work good
			mov hChk0,eax  				;Handle
				.if hChk0 == 1 			; 1 is Equal to:  BST_CHECKED
				invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
					mov Dat0,1  		;Carga 1 en variable Dat0
					.elseif hChk0 == 0 	; 0 is Equal to:  BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp

					mov Dat0,0			;Carga 0 en variable Dat0			
				xor ecx,ecx				;Clear ecx and == 0. 
				add ecx,Dat0			;Addin Dat0 to Register ECX.
				.endif
				jmp Salida				;Goto label Salida == (OUT).
		;-CHECK One----------------------
		.elseif eax == IDC_CHK1
			invoke IsDlgButtonChecked,hWin,IDC_CHK1
			;invoke SendDlgItemMessage,hWin,IDC_CHK1,BM_GETCHECK, 0, 0  ;It work good
			mov hChk1,eax  ;Quitando hChk1 y colocando IDC_CHK1 no trabaja bien
				.if hChk1 == BST_CHECKED  
				invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp1	
					mov Dat1,2
					.elseif hChk1 == BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp
					mov Dat1,0

				xor ecx,ecx
				add ecx,Dat1
				.endif
				jmp Salida
		;-CHECK Two----------------------
		.elseif eax == IDC_CHK2
			invoke SendDlgItemMessage,hWin,IDC_CHK2,BM_GETCHECK, 0, 0
			mov hChk2,eax  
				.if hChk2 == BST_CHECKED
				invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
					mov Dat2,4
					.elseif hChk2 == BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp

					mov Dat2,0

				xor ecx,ecx
				add ecx,Dat2
				.endif
				jmp Salida
		;-CHECK Three----------------------
		.elseif eax == IDC_CHK3
			invoke SendDlgItemMessage,hWin,IDC_CHK3,BM_GETCHECK, 0, 0
			mov hChk3,eax  
				.if hChk3 == BST_CHECKED
				invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
					mov Dat3,8
					.elseif hChk3 == BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp
					mov Dat3,0

				xor ecx,ecx
				add ecx,Dat3
				.endif
				jmp Salida
		;-CHECK Four----------------------
		.elseif eax == IDC_CHK4
			invoke SendDlgItemMessage,hWin,IDC_CHK4,BM_GETCHECK, 0, 0
			mov hChk4,eax  
				.if hChk4 == BST_CHECKED
				invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
					mov Dat4,16
					.elseif hChk4 == BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp
					mov Dat4,0

				xor ecx,ecx
				add ecx,Dat4
				.endif
				jmp Salida
		;-CHECK Five----------------------
		.elseif eax == IDC_CHK5
			invoke SendDlgItemMessage,hWin,IDC_CHK5,BM_GETCHECK, 0, 0
			mov hChk5,eax  
				.if hChk5 == BST_CHECKED
				invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
					mov Dat5,32
					.elseif hChk5 == BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp

					mov Dat5,0

				xor ecx,ecx
				add ecx,Dat5
				.endif
				jmp Salida
		;-CHECK Six----------------------
		.elseif eax == IDC_CHK6
			invoke SendDlgItemMessage,hWin,IDC_CHK6,BM_GETCHECK, 0, 0
			mov hChk6,eax  
				.if hChk6 == BST_CHECKED
				invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
					mov Dat6,64
					.elseif hChk6 == BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp
					mov Dat6,0

				xor ecx,ecx
				add ecx,Dat6
				.endif
				jmp Salida
		;-CHECK Seven----------------------
		.elseif eax == IDC_CHK7
			invoke SendDlgItemMessage,hWin,IDC_CHK7,BM_GETCHECK, 0, 0
			mov hChk7,eax  
				.if hChk7 == BST_CHECKED
				invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
					mov Dat7,128
					.elseif hChk7 == BST_UNCHECKED
					invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp
					mov Dat7,0

				xor ecx,ecx
				add ecx,Dat7
				.endif
				jmp Salida
			;----------------------
			
			Salida:
			.if Dat0 == 1 || Dat1 == 2 || Dat2 == 4 || Dat3 == 8\
			 || Dat4 == 16 || Dat5 == 32 || Dat6 == 64 || Dat7 == 128
			; When one of the Dat(n), this selected.  
				xor ecx,ecx		; Clear ECX and then  
				add ecx,Dat0	;adds their value in Register ECX.
				add ecx,Dat1	;Equal for the others.
				add ecx,Dat2
				add ecx,Dat3
				add ecx,Dat4
				add ecx,Dat5
				add ecx,Dat6
				add ecx,Dat7
			.endif
	.endif
	
;			mov eax,ecx 			;Load register ECX in register EAX.
;			invoke P_out1,1024,ecx 	;Out to LPT Port.

	ret
CheckProc endp

;========================================================================
ClearAll PROC hWin:DWORD
		;Esto es para el BitMap (.BMP)
		;invoke BitmapFromResource,hInstance,IDR_JPG
		mov eax,Carry
		mov	hBmp,eax
		invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp

		
		;Put all Check Box Unchecked				  
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
		mov bValue1,0

		;Para que muestre el valor Cero en el EDIT BOX.
		mov Val_Dat,0
		INVOKE SetDlgItemInt,hWin,IDC_EDT2,Val_Dat,FALSE

		;Limpia los Datos Almacenados. 
		mov Dat0,0	
		mov Dat1,0	
		mov Dat2,0
		mov Dat3,0
		mov Dat4,0
		mov Dat5,0
		mov Dat6,0
		mov Dat7,0
	
	ret

ClearAll endp

;========================================================================

end start






















